import uppercamelcase from 'uppercamelcase';
import Vue from 'vue';
import VueClickoutside from 'vue-clickoutside';
Vue.use(VueClickoutside);
Vue.directive('v-clickoutside', VueClickoutside);

const requireAll = requireContext => {
  return requireContext.keys().map(requireContext);
};
const modules = requireAll(require.context(
  'packages',
  true,
  /^((?!node_modules|message-box|notification|loading|lib|src).)*[^_]index\.js$/));

const components = {};

modules.forEach(item => {
  const name = uppercamelcase(item.name.replace(/^el-|El/, ''));
  components[name] = item;
});

import MessageBox from '../packages/message-box/index.js';
import Notification from '../packages/notification/index.js';
import Loading from '../packages/loading/index.js';

module.exports = Object.assign({}, {
  install(Vue) {
    Object.keys(components).forEach(key => {
      const item = components[key];
      Vue.component(item.name, item);
    });
    Object.defineProperty(Vue.prototype, '$msgbox', {
      get: () => {
        return MessageBox;
      }
    });
    Object.defineProperty(Vue.prototype, '$alert', {
      get: () => {
        return MessageBox.alert;
      }
    });
    Object.defineProperty(Vue.prototype, '$confirm', {
      get: () => {
        return MessageBox.confirm;
      }
    });
    Object.defineProperty(Vue.prototype, '$prompt', {
      get: () => {
        return MessageBox.prompt;
      }
    });
    Object.defineProperty(Vue.prototype, '$notify', {
      get: () => {
        return Notification;
      }
    });
    Vue.use(Loading);
  },
  MessageBox,
  Notification,
  Loading
}, components);
